package ru.sicamp.sicamphelper.api.bot

import mu.KLogging
import org.springframework.beans.factory.annotation.Value
import org.springframework.core.env.Environment
import org.springframework.stereotype.Component
import org.telegram.telegrambots.extensions.bots.commandbot.TelegramLongPollingCommandBot
import org.telegram.telegrambots.meta.api.methods.send.SendMessage
import org.telegram.telegrambots.meta.api.objects.Update
import org.telegram.telegrambots.starter.SpringWebhookBot
import ru.sicamp.sicamphelper.api.command.PublicCommand

@Component
class TelegramPublicBot(
    commands: List<PublicCommand<*, *>>,
    @Value("\${bot.username}")
    private val botName: String,
) : TelegramLongPollingCommandBot() { // TODO: switch to webHook?
    init {
        commands.forEach {
            register(it)
        }
    }

    override fun getBotUsername(): String {
        return botName
    }

    override fun processNonCommandUpdate(update: Update?) {
        logger.warn("Received non command update. Message: ${update?.message}")
    }

    companion object : KLogging()
}
