package ru.sicamp.sicamphelper.api.command

import java.time.LocalDate
import java.time.format.DateTimeParseException

fun String?.toLocalDate(): LocalDate? = try {
    LocalDate.parse(this)
} catch (e: DateTimeParseException) {
    null
}

const val EMPTY_TOKEN = "_"

fun Array<out String>.getValueOrNull(index: Int) = getOrNull(index)?.let { if (it == EMPTY_TOKEN) null else it }
