package ru.sicamp.sicamphelper.api.controller

import com.fasterxml.jackson.databind.ObjectMapper
import com.fasterxml.jackson.module.kotlin.convertValue
import mu.KLogging
import org.springframework.web.bind.annotation.*
import ru.sicamp.sicamphelper.model.dto.UserDto
import ru.sicamp.sicamphelper.service.UserService

@RestController
class UsersController(
    private val userService: UserService,
    private val objectMapper: ObjectMapper,
) {
    @PostMapping("/user/create")
    fun create(@RequestParam dto: UserDto): String {
        val user = userService.createUser(dto)
        return user.toString()
    }

    @GetMapping("/custom/users/find/{login}")
    fun getUser(@PathVariable(name = "login", required = true) login: String): String {
        logger.info("Getting user with username: $login!!!!!")
        return objectMapper.convertValue(userService.loadUserByUsername(login))
    }

    @GetMapping("/test")
    fun test() = "test"

    companion object : KLogging()
}