package ru.sicamp.sicamphelper.db.entity

import org.jetbrains.exposed.dao.LongEntity
import org.jetbrains.exposed.dao.LongEntityClass
import org.jetbrains.exposed.dao.id.EntityID
import ru.sicamp.sicamphelper.db.table.Events
import ru.sicamp.sicamphelper.db.table.Schedules

class Event(id: EntityID<Long>): LongEntity(id) {
    companion object : LongEntityClass<Event>(Events)
    
    var name by Events.name
    var type by Events.type
    var registrationType by Events.registrationType
    var group by Group optionalReferencedOn Events.group
    var eventDate by Events.eventDate
    var eventTime by Events.eventTime
    var repeat by Events.repeat
    var assigneeCount by Events.assigneeCount
    var status by Events.status
    var description by Events.description
    var responsible by User referencedOn Events.responsible
    var defaultRoom by Room optionalReferencedOn Events.defaultRoom
    val schedules by Schedule referrersOn Schedules.event
}