package ru.sicamp.sicamphelper.db.entity

import org.jetbrains.exposed.dao.LongEntity
import org.jetbrains.exposed.dao.LongEntityClass
import org.jetbrains.exposed.dao.id.EntityID
import ru.sicamp.sicamphelper.db.table.GroupRegistrations
import ru.sicamp.sicamphelper.db.table.Schedules
import ru.sicamp.sicamphelper.db.table.UserRegistrations

class Schedule(id: EntityID<Long>) : LongEntity(id) {
    companion object : LongEntityClass<Schedule>(Schedules)

    var dateTime by Schedules.start
    var description by Schedules.description
    var responsible by User referencedOn Schedules.responsible
    var event by Event referencedOn Schedules.event
    var room by Room optionalReferencedOn Schedules.room

    val userRegistrations by UserRegistration referrersOn UserRegistrations.schedule
    val groupRegistrations by GroupRegistration referrersOn  GroupRegistrations.schedule
}