/*
package ru.sicamp.sicamphelper.model.data

import kotlinx.serialization.DeserializationStrategy
import kotlinx.serialization.json.Json
import mu.KLogging
import org.jetbrains.exposed.sql.Column
import ru.sicamp.sicamphelper.db.table.Tables

class Change<T : Any>(
    change: String,
    private val deserializationStrategy: DeserializationStrategy<T>
) {
    val column: Column<T> = extractColumn(change)
    val newValue: T = extractValue(change)

    */
/**Extract change from string
     * @param change format: "table_name.column_name=newValue" *//*

    @Suppress("", "UNCHECKED_CAST")
    private fun extractColumn(change: String): Column<T> {
        if (!format.matches(change)) {
            throw BadFormatException(change)
        }

        val (columnAndTable, _) = change.split("=")
        val (tableName, columnName) = columnAndTable.split(".")

        val table = Tables.tableByName(tableName)?.table ?: throw BadFormatException(change)
        return table.columns.find { it.name == columnName } as Column<T>? ?: throw BadFormatException(change)
    }

    class BadFormatException(change: String) : Exception("Bad format exception for change: $change")

    private fun extractValue(change: String): T {
        if (!format.matches(change)) {
            throw BadFormatException(change)
        }

        val (_, valueString) = change.split("=")

        return Json.decodeFromString(deserializationStrategy, valueString)
    }

    private val format = "[\\w_]+\\.[\\w_]+=.+".toRegex()

    companion object : KLogging()
}*/
